//网络请求相关Api常量

class ApiConstants {
  //当前服务器环境
  static const isServerRelease = false;

  //域名
  static const baseUrl = isServerRelease ? 'http://dev-yyhome.guadoutech.com' : 'http://dev-yyhome.guadoutech.com';

  // =========================== 用户相关 ↓=========================================

  // 登录
  static const apiUserLogin = "/api/v1/user/auth/login";

  // 用户重置密码
  static const apiResetPassword = "/api/v1/user/me/setting/reset-password";

  // 用户忘记密码
  static const apiForgotPassword = "/api/v1/user/auth/forget-password";

  //用户注册
  static const apiAuthRegister = "/api/v1/user/auth/register";

  //验证码图片
  static const apiCaptchaImage = "/api/v1/user/captcha/index";

  //发送短信
  static const apiSendSMS = "/api/v1/user/sms/send";

  // 登出系统
  static const apiUserLogout = "/index.php/api/v1/hotel/logout";

  //用户注销
  static const apiAuthDeactivate = "/index.php/api/v1/hotel/deactivate";

  // =========================== 首页 ↓=========================================

  //反馈的分类列表
  static const apiFeedbackCategory = "/api/v1/user/feedback/category/index";

  //反馈的发布
  static const apiFeedbackPost = "/api/v1/user/feedback/index/publish";

  //已发布的反馈列表
  static const apiFeedbackList = "/api/v1/user/feedback/index";

  //反馈详情
  static const apiFeedbackDetail = "/api/v1/user/feedback/index/detail";

  //创建访客
  static const apiCreateVisitor = "/api/v1/user/visitor/index/apply";

  //访客状态列表
  static const apiVisitorList = "/api/v1/user/visitor/index";

  // =========================== Profile ↓=========================================

  //用户Me页面详情
  static const apiProfileInfo = "/api/v1/user/me/index";

  //更新用户信息
  static const apiUpdateProfile = "/api/v1/user/me/profile/update";

  //用户的默认头像列表
  static const apiDefaultAvatar = "/api/v1/user/me/profile/default-avatar";

  //修改手机号码
  static const apiChangeMobile = "/api/v1/user/me/setting/change-phone";

  //设置房产单元为默认
  static const apiSetEstateDefault = "/api/v1/user/estate/unit-user/set-default";

  //删除指定的房产单元
  static const apiDeleteEstateUnit = "/api/v1/user/estate/unit-user/delete";

  //搜索房产
  static const apiEstateSearch = "/api/v1/user/estate/estate/index";

  //加入房产的单元校验
  static const apiEstateUnitCheck = "/api/v1/user/estate/unit-user/join-check";

  //加入房产单元
  static const apiEstateUnitJoin = "/api/v1/user/estate/unit-user/join";

  // =========================== Form ↓=========================================

  // 在线表单的可申请列表
  static const apiFormList = "/api/v1/user/online-form/form/index";

  // 在线表单的已批准的申请
  static const apiFormApprovedList = "/api/v1/user/online-form/approved/index";

  // 在线表单的已拒绝的申请
  static const apiFormRejectedList = "/api/v1/user/online-form/rejected/index";

  // 在线表单的已提交的申请
  static const apiFormSubmittedList = "/api/v1/user/online-form/submitted/index";

  //在线表单的选项列表
  static const apiFormOption = "/api/v1/user/online-form/form/options";

  //在线表单的提交，注意后面要拼接type
  static const apiFormSubmit = "/api/v1/user/online-form/apply/submit/";

  //在线表单的提交详情
  static const apiFormDetail = "/api/v1/user/online-form/apply/detail";

  // =========================== Facility ↓=========================================

  //可用的设施列表
  static const apiFacilityList = "/api/v1/user/facility/type/index";

  //指定设施在指定日期下的可申请详情
  static const apiFacilityDate = "/api/v1/user/facility/type/detail";

  //预定指定的设施指定的日期
  static const apiFacilityBook = "/api/v1/user/facility/booking/book";

  //当前已预定的设施列表
  static const apiFacilityActiveList = "/api/v1/user/facility/active/index";

  //当前已预定的押金列表
  static const apiFacilityDepositList = "/api/v1/user/facility/deposit/index";

  //当前已预定的历史记录
  static const apiFacilityHistoryList = "/api/v1/user/facility/history/index";

  //获取预约Booking的详情
  static const apiFacilityBookingDetail = "/api/v1/user/facility/booking/detail";


  // =========================== 其他 ↓=========================================

  //服务器时间
  static const apiServerTime = "/index.php/api/employee/extra/time";
}
